#include <cstdio>
#include <cstring>
#include <cassert>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 510;

class DSet {
public:
	int father[MAXN];

	void init(int n) {
		for (int i = 0; i < n; i++) {
			father[i] = i;
		}
	}

	int getFather(int x) {
		int y = x;
		while (father[x] != x) x = father[x];
		while (father[y] != x) {
			int z = father[y];
			father[y] = x;
			y = z;
		}
		return x;
	}

	bool isFriend(int x, int y) {
		x = getFather(x);
		y = getFather(y);
		return x == y;
	}

	void setFriend(int x, int y) {
		x = getFather(x);
		y = getFather(y);
		father[x] = y;
	}
};

DSet q;
vector<pair<int, pair<int, int> > > edge;

int solve() {
	int n, m;
	scanf("%d%d", &n, &m);
	q.init(n);
	edge.clear();
	int cnt = 0;
	for (int i = 0; i < m; i++) {
		int a, b, c;
		scanf("%d%d%d", &a, &b, &c);
		if (c == 0) {
			q.setFriend(a, b);
			cnt ++;
		} else {
			edge.push_back(make_pair(c, make_pair(a, b)));
		}
	}
	sort(edge.begin(), edge.end());
	int res = 0;
	for (int i = 0; i < (int)edge.size(); i++) {
		if (q.isFriend(edge[i].second.first, edge[i].second.second)) continue;
		res += edge[i].first;
		q.setFriend(edge[i].second.first, edge[i].second.second);
	}
	return res;
}

int main() {
	int test;
	scanf("%d", &test);
	while (test--) {
		printf("%d\n", solve());
	}
	return 0;
}
