#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

const double INF = 1e100;
const double EPS = 1e-8;

inline double intersect(pair<double, double> l1, pair<double, double> l2) {
	return (l2.second - l1.second) / (l1.first - l2.first);
}

inline bool zero(double x) {
	return -EPS < x && x < EPS;
}

int solve() {
	int n;
	scanf("%d", &n);
	vector<pair<double, double> > line0, line;
	line0.resize(n);
	for (int i = 0; i < n; i++) {
		double a, b;
		scanf("%lf%lf", &a, &b);
		line0[i] = make_pair(a, b);
	}
	sort(line0.begin(), line0.end());
	for (int i = 0; i < n; i++) {
		if (i == 0 || !zero(line0[i].first - line.back().first)) {
			line.push_back(line0[i]);
		} else {
			line.back().second = line0[i].second;
		}
	}
	n = line.size();
	vector< pair< pair<double, double>, double> > v;
	v.push_back(make_pair(line[0], -INF));
	for (int i = 1; i < n; i++) {
		double x = intersect(line[i], v.back().first);
		while (x < v.back().second + EPS) {
			v.pop_back();
			x = intersect(line[i], v.back().first);
		}
		v.push_back(make_pair(line[i], x));
	}
	return v.size();
}

int main() {
	int test;
	scanf("%d", &test);
	while (test--) {
		printf("%d\n", solve());
	}
	return 0;
}

