#include <cstdio>
#include <cstring>

const int MAXN = 25;

int n;
double mul[MAXN][MAXN], res[MAXN][MAXN], init[MAXN];

void calc(double a[MAXN][MAXN], double b[MAXN][MAXN], double c[MAXN][MAXN]) {
	double d[MAXN][MAXN];
	memset(d, 0, sizeof(d));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int k = 0; k < n; k++) {
				d[i][j] += b[i][k] * c[k][j];
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			a[i][j] = d[i][j];
		}
	}
}

void solve() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%lf", &init[i]);
	}
	memset(mul, 0, sizeof(mul));
	for (int i = 0; i < n; i++) {
		int k;
		scanf("%d", &k);
		if (k == 0) {
			mul[i][i] = 1;
		} else {
			for (int j = 0; j < k; j++) {
				int x;
				scanf("%d", &x);
				mul[x - 1][i] = 1.0 / k;
			}
		}
	}

	int m;
	scanf("%d", &m);
	memset(res, 0, sizeof(res));
	for (int i = 0; i < n; i++) {
		res[i][i] = 1;
	}
	for (; m; m >>= 1) {
		if (m & 1) calc(res, res, mul);
		calc(mul, mul, mul);
	}

	for (int i = 0; i < n; i++) {
		double ans = 0;
		for (int j = 0; j < n; j++) {
			ans += res[i][j] * init[j];
		}
		printf("%.2lf%c", ans, i == (n - 1) ? '\n' : ' ');
	}
}

int main() {
	int test;
	scanf("%d", &test);
	while (test--) {
		solve();
	}
	return 0;
}
