#include <cstdio>
#include <cstring>
#include <cmath>

const int MAXN = 110;

int x[MAXN], y[MAXN], z[MAXN], I[MAXN];

double dist(int x1, int y1, int n) {
	int x2 = x[n], y2 = y[n];
	return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) + z[n] * z[n]);
}

double calc(int X, int Y, int n) {
	double R = dist(X, Y, n);
	return (double)I[n] / R / R / R * z[n];
}

double solve() {
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d%d", &x[i], &y[i], &z[i], &I[i]);
	}
	double best = -1.0;
	for (int i = -100; i <= 100; i++) {
		for (int j = -100; j <= 100; j++) {
			double tot = 0;
			for (int k = 0; k < n; k++) {
				tot += calc(i, j, k);
			}
			if (tot > best) best = tot;
		}
	}
	return best;
}

int main() {
	int test;
	scanf("%d", &test);
	while (test--) {
		printf("%.2lf\n", solve());
	}
	return 0;
}
