#include <cstdio>
#include <cstring>

const int INF = 100000000;

int dp[120][120];

void update(int &x, int y) {
	if (y < x) x = y;
}

int min(int x, int y) {
	return x < y ? x : y;
}

int solve() {
	int n, M, T1, T2, T3, F1, F2;
	scanf("%d%d", &n, &M);
	for (int i = 0; i <= n; i++)
		for (int j = 0; j <= M; j++)
			dp[i][j] = INF;
	dp[0][M] = 0;
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d%d%d", &T1, &T2, &T3, &F1, &F2);
		for (int j = 0; j <= M; j++) {
			// Fast Mode
			if (j >= F1) {
				update(dp[i + 1][j - F1], dp[i][j] + T1);
			}
			// Normal Mode
			update(dp[i + 1][j], dp[i][j] + T2);
			// Slow Mode
			update(dp[i + 1][min(M, j + F2)], dp[i][j] + T3);
		}
	}
	int best = dp[n][0];
	for (int i = 1; i <= M; i++) {
		update(best, dp[n][i]);
	}
	return best;
}

int main() {
	int test;
	scanf("%d", &test);
	while (test--) {
		printf("%d\n", solve());
	}
	return 0;
}
